// RegKey.cpp: CRegKey NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CedarFTP.h"
#include "RegKey.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CRegKey::CRegKey()
{
	m_hKey = NULL;
}

CRegKey::~CRegKey()
{
	Close();
}

LONG CRegKey::Open (HKEY hKeyRoot, LPCTSTR pszPath)
{
    DWORD dw;
    m_sPath = pszPath;
	
	return RegCreateKeyEx (hKeyRoot, pszPath, 0L, L"",
		0, 0, NULL, &m_hKey, &dw);
}

void CRegKey::Close()
{
	if (m_hKey)
	{
		RegCloseKey (m_hKey);
		m_hKey = NULL;
	}
}

LONG CRegKey::Write (LPCTSTR pszKey, DWORD dwVal)
{//l̏
	return RegSetValueEx (m_hKey, pszKey, 0L, REG_DWORD,
		(CONST BYTE*) &dwVal, sizeof(DWORD));
}

LONG CRegKey::Write (LPCTSTR pszKey, LPCTSTR pszData)
{//̏
	return RegSetValueEx (m_hKey, pszKey, 0L, REG_SZ,
		(CONST BYTE*) pszData, (_tcslen(pszData) + 1) * sizeof (*pszData));

}

LONG CRegKey::Write (LPCTSTR pszKey, const BYTE* pData,
                     DWORD dwLength)
{//oCȉ
	return RegSetValueEx (m_hKey, pszKey, 0L, REG_BINARY,
		pData, dwLength);
}

LONG CRegKey::Read (LPCTSTR pszKey, DWORD& dwVal)
{//l̓ǂݍ
	DWORD dwType;
	DWORD dwSize = sizeof (DWORD);
	DWORD dwDest;
	
	LONG lRet = RegQueryValueEx (m_hKey, (LPTSTR) pszKey, NULL,
		&dwType, (BYTE *) &dwDest, &dwSize);
	
	if (lRet == ERROR_SUCCESS)
		dwVal = dwDest;
	
	return lRet;
}

LONG CRegKey::Read (LPCTSTR pszKey, CString& sVal)
{//̓ǂݍ
	DWORD dwType;
	DWORD dwSize = 200;
	TCHAR  string[200];
	
	LONG lReturn = RegQueryValueEx (m_hKey, (LPTSTR) pszKey, NULL,
		&dwType, (BYTE *) string, &dwSize);
	
	if (lReturn == ERROR_SUCCESS)
		sVal = string;
	else
		sVal = L"";
	
	return lReturn;
}

LONG CRegKey::Read (LPCTSTR pszKey, BYTE* pData, DWORD& dwLen)
{//oCi̓ǂݍ
	DWORD dwType;
	
	return RegQueryValueEx (m_hKey, (LPTSTR) pszKey, NULL,
		&dwType, pData, &dwLen);
}

LONG CRegKey::Delete(HKEY hKeyRoot, LPCTSTR pszPath)
{
	return RegDeleteKey(hKeyRoot, pszPath);
}

